﻿Imports System.Data
Imports System.Data.SqlClient

Public Class Form1
    Public Sub New()
        InitializeComponent()
    End Sub

    'Set the Page Size.
    Private PageSize As Integer = 5
    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles Me.Load
        Me.BindGrid(1)
    End Sub

    Private Sub BindGrid(pageIndex As Integer)
        Dim constring As String = "Data Source=.\SQL2005;Initial Catalog=Northwind;Integrated Security=true"
        Using con As New SqlConnection(constring)
            Using cmd As New SqlCommand("GetCustomersPageWise", con)
                cmd.CommandType = CommandType.StoredProcedure
                cmd.Parameters.AddWithValue("@PageIndex", pageIndex)
                cmd.Parameters.AddWithValue("@PageSize", PageSize)
                cmd.Parameters.Add("@RecordCount", SqlDbType.Int, 4)
                cmd.Parameters("@RecordCount").Direction = ParameterDirection.Output
                con.Open()
                Dim dt As New DataTable()
                dt.Load(cmd.ExecuteReader())
                dataGridView1.DataSource = dt
                con.Close()
                Dim recordCount As Integer = Convert.ToInt32(cmd.Parameters("@RecordCount").Value)
                Me.PopulatePager(recordCount, pageIndex)
            End Using
        End Using
    End Sub

    Private Sub PopulatePager(recordCount As Integer, currentPage As Integer)
        Dim pages As New List(Of Page)()
        Dim startIndex As Integer, endIndex As Integer
        Dim pagerSpan As Integer = 5

        'Calculate the Start and End Index of pages to be displayed.
        Dim dblPageCount As Double = CDbl(CDec(recordCount) / Convert.ToDecimal(PageSize))
        Dim pageCount As Integer = CInt(Math.Ceiling(dblPageCount))
        startIndex = If(currentPage > 1 AndAlso currentPage + pagerSpan - 1 < pagerSpan, currentPage, 1)
        endIndex = If(pageCount > pagerSpan, pagerSpan, pageCount)
        If currentPage > pagerSpan Mod 2 Then
            If currentPage = 2 Then
                endIndex = 5
            Else
                endIndex = currentPage + 2
            End If
        Else
            endIndex = (pagerSpan - currentPage) + 1
        End If

        If endIndex - (pagerSpan - 1) > startIndex Then
            startIndex = endIndex - (pagerSpan - 1)
        End If

        If endIndex > pageCount Then
            endIndex = pageCount
            startIndex = If(((endIndex - pagerSpan) + 1) > 0, (endIndex - pagerSpan) + 1, 1)
        End If

        'Add the First Page Button.
        If currentPage > 1 Then
            pages.Add(New Page() With { _
              .Text = "First", _
              .Value = "1" _
            })
        End If

        'Add the Previous Button.
        If currentPage > 1 Then
            pages.Add(New Page() With { _
              .Text = "<<", _
              .Value = (currentPage - 1).ToString() _
            })
        End If

        For i As Integer = startIndex To endIndex
            pages.Add(New Page() With { _
              .Text = i.ToString(), _
              .Value = i.ToString(), _
              .Selected = i = currentPage _
            })
        Next

        'Add the Next Button.
        If currentPage < pageCount Then
            pages.Add(New Page() With { _
              .Text = ">>", _
              .Value = (currentPage + 1).ToString() _
            })
        End If

        'Add the Last Button.
        If currentPage <> pageCount Then
            pages.Add(New Page() With { _
              .Text = "Last", _
              .Value = pageCount.ToString() _
            })
        End If

        'Clear existing Pager Buttons.
        pnlPager.Controls.Clear()

        'Loop and add Buttons for Pager.
        Dim count As Integer = 0
        For Each page As Page In pages
            Dim btnPage As New Button()
            btnPage.Location = New System.Drawing.Point(38 * count, 5)
            btnPage.Size = New System.Drawing.Size(35, 20)
            btnPage.Name = page.Value
            btnPage.Text = page.Text
            btnPage.Enabled = Not page.Selected
            AddHandler btnPage.Click, AddressOf Page_Click
            pnlPager.Controls.Add(btnPage)
            count += 1
        Next
    End Sub

    Private Sub Page_Click(sender As Object, e As EventArgs)
        Dim btnPager As Button = TryCast(sender, Button)
        Me.BindGrid(Integer.Parse(btnPager.Name))
    End Sub

    Public Class Page
        Public Property Text() As String
        Public Property Value() As String
        Public Property Selected() As Boolean
    End Class
End Class

